unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    TextUtil;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  50MB̃t@C
procedure TForm1.Button1Click(Sender: TObject);
begin
    Screen.Cursor := crHourGlass;
    CreateMegaByteFile(ChangeFileExt(ParamStr(0), '.txt'), 50);
    Screen.Cursor := crDefault;
end;

//-----------------------------------------------------------------------------
//  Ō1MBǂݍ(TFileStream)
procedure TForm1.Button2Click(Sender: TObject);
var
    FileName: string;
    TickCount: Cardinal;
    MemCount: Integer;
    StringList: TStringList;
    FileStream: TFileStream;
    NewPosition: Int64;
begin
    //  ǂݍރt@C̖O
    FileName := ChangeFileExt(ParamStr(0), '.txt');

    //  Ȃ΂߂
    if (not FileExists(FileName)) then Exit;

    //  J[\ςĂ܂
    Screen.Cursor := crHourGlass;

    //  IuWFNg
    StringList := nil;
    FileStream := nil;

    //  ԌvJn
    Label1.Caption := '---';
    TickCount := GetTickCount();

    //  vJn
    MemCount := AllocMemSize;

    try
        try
            //  Ǎ
            StringList := TStringList.Create;

            //  Xg[Ƀt@C蓖Ă܂(̑SANZX)
            FileStream := TFileStream.Create(FileName, fmShareDenyNone);

            //  납琔1MB̈ʒu܂ő
            //FileStream.Seek(1024 * 1024, soFromEnd);
            NewPosition := FileStream.Size - 1024 * 1024;
            if (NewPosition < 0) then NewPosition := 0;
            FileStream.Seek(NewPosition, soFromBeginning);

            //  񃊃Xgɓǂݍ݂܂(Ƃ肠RS[)
            StringList.LoadFromStream(FileStream);

            //  ԌvI
            Label1.Caption := FormatFloat('#,##0 msec', GetTickCount() - TickCount);

            //  vI
            Label3.Caption := FormatFloat('#,##0 kbyte', (AllocMemSize - MemCount) / 1024);

            //  zgɓǂ񂾂H
            //Memo1.Lines.Assign(StringList);
        finally
            FileStream.Free;
            StringList.Free;
        end;
    except
        ;
    end;

    //  J[\ɖ߂
    Screen.Cursor := crDefault;
end;

//-----------------------------------------------------------------------------
//  Ō1MBǂݍ(FileSeek)
procedure TForm1.Button3Click(Sender: TObject);
var
    FileName: string;
    TickCount: Cardinal;
    MemCount: Integer;
    StringList: TStringList;
    F: File;
    Size, ReadSize: Cardinal;
    SearchRec: TSearchRec;
    Buf: string;
    NewPosition: Int64;
begin
    //  ǂݍރt@C̖O
    FileName := ChangeFileExt(ParamStr(0), '.txt');

    //  Ȃ΂߂
    if (not FileExists(FileName)) then Exit;

    //  J[\ςĂ܂
    Screen.Cursor := crHourGlass;

    //  IuWFNg
    StringList := nil;

    //  ԌvJn
    Label2.Caption := '---';
    TickCount := GetTickCount();

    //  vJn
    MemCount := AllocMemSize;

    //  t@CTCY擾
    Size := 0;
    if FindFirst(FileName, faAnyFile, SearchRec) = 0 then
    begin
        Size := SearchRec.Size;
        FindClose(SearchRec);
    end;

    //  0ȏȂ
    if (Size > 0) then
    begin
        try
            //  t@C蓖
            AssignFile(F, FileName);
            try
                //  Ǎ
                StringList := TStringList.Create;

                //  t@CI[v
                Reset(F, 1);

                //  납琔1MB̈ʒu܂ő
                NewPosition := Size - 1024 * 1024;
                if (NewPosition < 0) then NewPosition := 0;

                //  ǂݍ݃obt@̃TCYݒ
                SetLength(Buf, Size - NewPosition);

                //  ǂݍ
                BlockRead(F, PChar(Buf)^, Size - NewPosition, ReadSize);
                StringList.Text := Buf;

                //  ԌvI
                Label2.Caption := FormatFloat('#,##0 msec', GetTickCount() - TickCount);

                //  vI
                Label4.Caption := FormatFloat('#,##0 kbyte', (AllocMemSize - MemCount) / 1024);

                //  zgɓǂ񂾂H
                //Memo1.Lines.Assign(StringList);
            finally
                //  t@CN[Y
                CloseFile(F);
                StringList.Free;
            end;
        except
            ;
        end;
    end;

    //  J[\ɖ߂
    Screen.Cursor := crDefault;
end;

end.
